#include <linux/kernel.h>
#include <linux/init.h>
#if defined (__KERNEL__)  //|| !defined (__CTP__)
#include <linux/export.h>
#include <linux/module.h>
#endif //#if !defined (__CTP__)

/*********************************
 * macro for log
 **********************************/
#define SPOWER_LOG_NONE                                0
#define SPOWER_LOG_WITH_PRINTK                         1

//#define SPOWER_LOG_PRINT SPOWER_LOG_WITH_PRINTK
#define SPOWER_LOG_PRINT SPOWER_LOG_NONE

#if (SPOWER_LOG_PRINT == SPOWER_LOG_NONE)
#define SPOWER_INFO(fmt, args...)
#elif (SPOWER_LOG_PRINT == SPOWER_LOG_WITH_PRINTK)
#define SPOWER_INFO(fmt, args...)		printk("[Power/spower] "fmt, ##args)
#endif

/****************************************************************
 * this table is generated by scramble function.                *
 * (plz refer to DE team.)                                      *
 ****************************************************************/
int devinfo_table[] = {
		3539,   492,    1038,   106,    231,    17,     46,     2179,
		4,      481,    1014,   103,    225,    17,     45,     2129,
		3,      516,    1087,   111,    242,    19,     49,     2282,
		4,      504,    1063,   108,    236,    18,     47,     2230,
		4,      448,    946,    96,     210,    15,     41,     1986,
		2,      438,    924,    93,     205,    14,     40,     1941,
		2,      470,    991,    101,    220,    16,     43,     2080,
		3,      459,    968,    98,     215,    16,     42,     2033,
		3,      594,    1250,   129,    279,    23,     57,     2621,
		6,      580,    1221,   126,    273,    22,     56,     2561,
		6,      622,    1309,   136,    293,    24,     60,     2745,
		7,      608,    1279,   132,    286,    23,     59,     2683,
		6,      541,    1139,   117,    254,    20,     51,     2390,
		5,      528,    1113,   114,    248,    19,     50,     2335,
		4,      566,    1193,   123,    266,    21,     54,     2503,
		5,      553,    1166,   120,    260,    21,     53,     2446,
		5,      338,    715,    70,     157,    9,      29,     1505,
		3153,   330,    699,    69,     153,    9,      28,     1470,
		3081,   354,    750,    74,     165,    10,     31,     1576,
		3302,   346,    732,    72,     161,    10,     30,     1540,
		3227,   307,    652,    63,     142,    8,      26,     1371,
		2875,   300,    637,    62,     139,    7,      25,     1340,
		2809,   322,    683,    67,     149,    8,      27,     1436,
		3011,   315,    667,    65,     146,    8,      26,     1404,
		2942,   408,    862,    86,     191,    13,     37,     1811,
		1,      398,    842,    84,     186,    12,     36,     1769,
		1,      428,    903,    91,     200,    14,     39,     1896,
		2,      418,    882,    89,     195,    13,     38,     1853,
		2,      371,    785,    78,     173,    11,     33,     1651,
		3458,   363,    767,    76,     169,    10,     32,     1613,
		3379,   389,    823,    82,     182,    12,     35,     1729,
		1,      380,    804,    80,     177,    11,     34,     1689,
	
};

extern u32 get_devinfo_with_index(u32 index);

int mt_spower_init(void)
{
#define DEVINFO_IDX0 (34)
#define DEVINFO_MP1_BIT (0)
    int devinfo = 0;
	int cpu;

	devinfo = (int)get_devinfo_with_index(DEVINFO_IDX0);// ptp_read(0x1000918C); /* M_HW_RES3 */
	cpu = (devinfo >> DEVINFO_MP1_BIT) & 0x0ff;
	SPOWER_INFO("[SPOWER] - scrambled cpu => 0x%x\n", cpu);

	if (devinfo != 0) {
		cpu = (int)devinfo_table[cpu];
		SPOWER_INFO("[SPOWER] - de-scrambled cpu => %d\n", cpu);
	}
	else {
		SPOWER_INFO("[SPOWER] - No EFUSE\n");
	}

	return 0;
}

late_initcall(mt_spower_init);

